#/usr/bin/env python
"""
Urban Ninja Random Map Maker
http://www.pyweek.org/3/

Coded by Cthulhu32 (Luke A.)
"""

#Import Modules
import os, pygame
from pygame.locals import *

from level import Level

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'

#functions to create our resources
def load_image(name, colorkey=None):
    fullname = os.path.join('Data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

def createLevel(name):
    fullname = os.path.join('Levels', name)
    FILE = open(fullname, "w")
    FILE.write('Room')
    for i in range(0, 7):
        FILE.write(chr(i))

    FILE.close()
        
def main():
    """T3h Main Functionz
        Word"""
#Initialize Everything
    pygame.init()
    screen = pygame.display.set_mode((640, 480))
    pygame.display.set_caption('Urban Ninja   -  {Pyweek3} Luke Arntson \'06')
    pygame.mouse.set_visible(0)

    createLevel('TestLevel.txt')

#Create The Backgound
    background = pygame.Surface(screen.get_size())
    background = background.convert()
    background.fill((255, 255, 255))

    shadow = pygame.Surface(screen.get_size())
    shadow = shadow.convert()


    overlay, overlayRect = load_image('overlay.gif')
    
#Display The Background
    screen.blit(background, (0, 0))
    pygame.display.flip()

#Prepare Game Objects
    clock = pygame.time.Clock()

    # setup our shadow
    shadow.fill((0, 0, 0))
    shadow.set_colorkey((0,255,0), RLEACCEL)
    shadow.set_alpha(180)
    # Level class
    currentLevel = Level('TestLevel.txt', background, shadow)

    font = pygame.font.Font(None, 24)
    text = font.render(0, 1, (255, 255, 255))

    #Main Loop
    while not currentLevel.complete():
        clock.tick(60)

    #Handle Input Events
        for event in pygame.event.get():
            if event.type == QUIT:
                return
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                return

        allsprites.update()

    #Draw Everything
        screen.blit(background, (0, 0))
        screen.blit(shadow, (0, 0))
        screen.blit(overlay, (0, 0))
        text = font.render(str(int(clock.get_fps())), 1, (255, 255, 255))
        screen.blit(text, (0, 0))
        
        pygame.display.flip()

#Game Over


#this calls the 'main' function when this script is executed
if __name__ == '__main__': main()
